package cn.gbase8.gswt;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.Properties;

import util.Common;

public class Function {
	public String sql;
	public String comment;
	public String filename;
	public String up = "N";

	public boolean loadFromFile(File file) {
		InputStream in = null;
		try {
			in = new BufferedInputStream(new FileInputStream(file));
			InputStreamReader isr = new InputStreamReader(in, "UTF-8");
			Properties prop = new Properties();
			prop.load(isr);
			sql = prop.getProperty("sql");
			comment = prop.getProperty("comment");
			filename = prop.getProperty("filename");
			up = Common.noNull(prop.getProperty("up"), "N");
			in.close();
			return true;

		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}

	}

	public boolean saveToFile(File file) {
		OutputStream output = null;
		try {
			output = new FileOutputStream(file);
			OutputStreamWriter osw = new OutputStreamWriter(output, "UTF-8");
			Properties prop = new Properties();
			prop.setProperty("sql", sql);
			prop.setProperty("comment", comment);
			prop.setProperty("filename", filename);
			prop.setProperty("up", Common.noNull(up, "N"));
			prop.store(osw, filename);
			output.close();

			return true;

		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}
	}
}
