package cn.gbase8.gswt;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.Properties;

import util.Common;

public class GBaseConnectionParamater {
	public String loginUsername;
	public String serverIP;
	public int port = 5258;
	public String username = "gbase";
	public String password = "gbase20110531";
	public String dbName = "information_schema";
	public boolean checked = false;
	public String comment = "";
	public String filename = "";
	public static final int limit_MAX = 10000;
	public static final int limit_DEFAULT = 1000;
	public static final int timeout_DEFAULT = 60;

	// 最大结果集行数
	private int limit = 1000;

	public int getLimit() {
		return limit;
	}

	public void setLimit(int limit) {
		// 最小1行，最大limit_MAX
		this.limit = Math.max(Math.min(limit, limit_MAX), 1);
	}

	public int getTimeout() {
		return timeout;
	}

	public void setTimeout(int timeout) {
		// 最小1秒，最大不限制
		this.timeout = Math.max(1, timeout);
	}

	// 查询超时时间
	private int timeout = 60;

	public boolean loadFromFile(File file) {
		InputStream in = null;
		try {
			in = new BufferedInputStream(new FileInputStream(file));
			InputStreamReader isr = new InputStreamReader(in, "UTF-8");
			Properties prop = new Properties();
			prop.load(isr);
			serverIP = prop.getProperty("serverIP");
			port = Integer.valueOf(prop.getProperty("port"));
			username = prop.getProperty("username");
			password = prop.getProperty("password");
			dbName = prop.getProperty("dbName");
			comment = prop.getProperty("comment");
			filename = prop.getProperty("filename");
			setLimit(Integer.valueOf(Common.noNull(prop.getProperty("limit"), Integer.toString(limit_DEFAULT))));
			setTimeout(Integer.valueOf(Common.noNull(prop.getProperty("timeout"), Integer.toString(timeout_DEFAULT))));
			in.close();
			return true;

		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}

	}

	public boolean saveToFile(File file) {
		OutputStream output = null;
		try {
			output = new FileOutputStream(file);
			OutputStreamWriter osw = new OutputStreamWriter(output, "UTF-8");
			Properties prop = new Properties();
			prop.setProperty("serverIP", serverIP);
			prop.setProperty("port", Integer.toString(port));
			prop.setProperty("username", username);
			prop.setProperty("password", password);
			prop.setProperty("dbName", dbName);
			prop.setProperty("comment", comment);
			prop.setProperty("filename", filename);
			prop.setProperty("limit", Integer.toString(limit));
			prop.setProperty("timeout", Integer.toString(timeout));
			prop.store(osw, filename);

			output.close();

			return true;

		} catch (IOException e) {
			e.printStackTrace();
			return false;
		}
	}
}
